struct _IO_FILE;
typedef struct _IO_FILE FILE;
extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stderr;
void __VERIFIER_assume(int cond) {
    if(!cond) {
        abort();
    }
}

char * read_bytes(char * __inp_var) {
    unsigned int input_length = strlen(__inp_var)-1;
    /* Remove '\n' at end of input */
    if (__inp_var[input_length] == '\n') {
        __inp_var[input_length] = '\0';
    }

    char * parseEnd;
    char * value_pointer = malloc(16);

    unsigned long long intVal = strtoull(__inp_var, &parseEnd, 0);
    if (*parseEnd != 0) {
      long long sintVal = strtoll(__inp_var, &parseEnd, 0);
      if (*parseEnd != 0) {
        long double floatVal = strtold(__inp_var, &parseEnd);
        if (*parseEnd != 0) {
          fprintf(stderr, "Can't parse input: '%s' (failing at '%s')\n", __inp_var, parseEnd);
          abort();

        } else {
          memcpy(value_pointer, &floatVal, 16);
        }
      } else {
        memcpy(value_pointer, &sintVal, 8);
      }
    } else {
      memcpy(value_pointer, &intVal, 8);
    }

    return value_pointer;
}

void __VERIFIER_error() {
    fprintf(stderr, "Error found.\n");
    exit(42);
}

unsigned int access_counter = 0;

char * strncpy_ptr(char * param0, char const * param1, size_t param2) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((char * *) read_bytes(inp_var));
}

int isspace(int param0) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

char * strrand(char * param0) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((char * *) read_bytes(inp_var));
}

int istrrand(char * param0) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

int istrchr(char const * param0, int param1) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

int istrrchr(char const * param0, int param1) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

int istrncmp(char const * param0, int param1, char const * param2, size_t param3) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

int istrstr(char const * param0, char const * param1) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((int *) read_bytes(inp_var));
}

char * r_strncpy(char * param0, char const * param1, size_t param2) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((char * *) read_bytes(inp_var));
}

char * r_strcpy(char * param0, char const * param1) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((char * *) read_bytes(inp_var));
}

char * r_strcat(char * param0, char const * param1) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((char * *) read_bytes(inp_var));
}

char * r_strncat(char * param0, char const * param1, size_t param2) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((char * *) read_bytes(inp_var));
}

void * r_memcpy(void * param0, void const * param1, size_t param2) {
    unsigned int inp_size = 3000;
    char * inp_var = malloc(inp_size);
    switch(access_counter) {
case 0: strcpy(inp_var, "0"); break;
        default: abort();
    }
    access_counter++;
    return *((void * *) read_bytes(inp_var));
}

